-- Licensed Materials - Property of IBM
-- 
-- (C) Copyright IBM Corp. 2007, 2011 All Rights Reserved
-- 
-- US Government Users Restricted Rights - Use, duplicate or
-- disclosure restricted by GSA ADP Schedule Contract with
-- IBM Corp.
-- 
CREATE TABLE OPENJPA_SEQUENCE_TABLE (ID TINYINT NOT NULL, SEQUENCE_VALUE BIGINT, PRIMARY KEY NONCLUSTERED (ID));
CREATE TABLE WKF_DCM_OBJECT (DCM_OBJECT_ID BIGINT NOT NULL, CREATE_TS DATETIME, description VARCHAR(2000), DISPLAY_NAME VARCHAR(256), guid VARCHAR(32), locale VARCHAR(256), LOCKED_UNTIL BIGINT, MODIFY_TS DATETIME, name VARCHAR(765), NAME_LOWER_CASE VARCHAR(765), ROW_VERSION BIGINT, SOURCE_TOKENS VARCHAR(1024), DEVICE_MODEL_ID BIGINT, PHYSICAL_CONTAINER_ID BIGINT, TYPE_ID BIGINT NOT NULL, PRIMARY KEY NONCLUSTERED (DCM_OBJECT_ID));
CREATE TABLE WKF_DCM_OBJECT_TYPE (TYPE_ID BIGINT NOT NULL, description VARCHAR(2000), name VARCHAR(256) NOT NULL, SUPER_TYPE_ID BIGINT, PRIMARY KEY NONCLUSTERED (TYPE_ID));
CREATE TABLE WKF_DCM_OBJECT_WORKFLOW (DCM_OBJECT_WORKFLOW_ID BIGINT NOT NULL, WORKFLOW_NAME VARCHAR(255) NOT NULL, DCM_OBJECT_ID BIGINT NOT NULL, PRIMARY KEY NONCLUSTERED (DCM_OBJECT_WORKFLOW_ID));
CREATE TABLE WKF_DEPLOYMENT_REQUEST (DEPLOYMENT_REQUEST_ID BIGINT NOT NULL, attempts INT, IS_CANCELLED VARCHAR(1) NOT NULL, CREATE_DATETIME DATETIME NOT NULL, CREATE_USERNAME VARCHAR(256), ERROR_CODE VARCHAR(255), ERROR_DETAIL TEXT, ERROR_MESSAGE VARCHAR(4000), guid VARCHAR(128), IS_IN_PROGRESS VARCHAR(1) NOT NULL, PENDING_ACTION VARCHAR(20), PENDING_INTERACTION_REQUEST_ID BIGINT, IS_SUCCESSFUL VARCHAR(1) NOT NULL, WORKFLOW_NAME VARCHAR(255), PRIMARY KEY NONCLUSTERED (DEPLOYMENT_REQUEST_ID));
CREATE TABLE WKF_DEVICE_MODEL (DEVICE_MODEL_ID BIGINT NOT NULL, category VARCHAR(255), description TEXT, descriptor TEXT, name VARCHAR(255), TCDRIVER_ID BIGINT, DCM_OBJECT_ID BIGINT, PRIMARY KEY NONCLUSTERED (DEVICE_MODEL_ID));
CREATE TABLE WKF_EXCEPTION_HANDLER (EXCEPTION_HANDLER_ID BIGINT NOT NULL, EXCEPTION_TYPE VARCHAR(256), FIRST_INSTRUCTION_INDEX INT NOT NULL, HANDLER_POSITION INT NOT NULL, HANDLER_TYPE VARCHAR(256) NOT NULL, INSTRUCTION_ID BIGINT NOT NULL, PRIMARY KEY NONCLUSTERED (EXCEPTION_HANDLER_ID));
CREATE TABLE WKF_EXECUTION_LOG (LOG_ID BIGINT NOT NULL, CALL_STACK_LEVEL INT NOT NULL, datetime DATETIME NOT NULL, LOG_LEVEL VARCHAR(256) NOT NULL, position INT NOT NULL, RECORD_TYPE VARCHAR(30), text VARCHAR(4000), WORKFLOW_NAME VARCHAR(255) NOT NULL, DEPLOYMENT_REQUEST_ID BIGINT NOT NULL, PRIMARY KEY NONCLUSTERED (LOG_ID));
CREATE TABLE WKF_EXECUTION_LOG_DETAIL (WF_EXEC_LOG_DETAIL_ID BIGINT NOT NULL, ARRAY_INDEX INT, IS_ENCRYPTED VARCHAR(1) NOT NULL, name VARCHAR(256) NOT NULL, position INT NOT NULL, value VARCHAR(4000), LOG_ID BIGINT NOT NULL, PRIMARY KEY NONCLUSTERED (WF_EXEC_LOG_DETAIL_ID));
CREATE TABLE WKF_FORMAL_PARAMETER (FORMAL_PARAMETER_ID BIGINT NOT NULL, IS_ARRAY VARCHAR(1) NOT NULL, IS_ENCRYPTED VARCHAR(1) NOT NULL, IS_INPUT VARCHAR(1) NOT NULL, PARAMETER_NAME VARCHAR(256) NOT NULL, IS_OUTPUT VARCHAR(1) NOT NULL, PARAMETER_POSITION INT NOT NULL, WORKFLOW_ID BIGINT NOT NULL, PRIMARY KEY NONCLUSTERED (FORMAL_PARAMETER_ID));
CREATE TABLE WKF_FORMAL_PARM_PERM (FORMAL_PARAMETER_PERMISSION_ID BIGINT NOT NULL, INSTANCE_PERMISSION_ID BIGINT NOT NULL, FORMAL_PARAMETER_ID BIGINT NOT NULL, PRIMARY KEY NONCLUSTERED (FORMAL_PARAMETER_PERMISSION_ID));
CREATE TABLE WKF_INSTRUCTION (INSTRUCTION_ID BIGINT NOT NULL, INSTRUCTION_INDEX INT NOT NULL, IS_XA VARCHAR(1) NOT NULL, opcode VARCHAR(256) NOT NULL, SOURCE_COLUMN INT NOT NULL, SOURCE_LINE INT NOT NULL, WORKFLOW_ID BIGINT NOT NULL, PRIMARY KEY NONCLUSTERED (INSTRUCTION_ID));
CREATE TABLE WKF_INSTRUCTION_OPERAND (OPERAND_ID BIGINT NOT NULL, OPERAND_INDEX INT NOT NULL, OPERAND_NAME VARCHAR(256) NOT NULL, OPERAND_TYPE VARCHAR(256) NOT NULL, SOURCE_COLUMN INT NOT NULL, SOURCE_LINE INT NOT NULL, INSTRUCTION_ID BIGINT NOT NULL, WORKFLOW_ID BIGINT NOT NULL, IS_EMPTY_STRING VARCHAR(1), STRING_VALUE VARCHAR(4000), NAME_VALUE VARCHAR(256), CLOB_VALUE TEXT, INTEGER_VALUE INT, BOOLEAN_VALUE VARCHAR(1), PRIMARY KEY NONCLUSTERED (OPERAND_ID));
CREATE TABLE WKF_JAVA_PLUGIN (JAVA_PLUGIN_ID BIGINT NOT NULL, deprecated VARCHAR(2000), description VARCHAR(2000), CLASS_NAME VARCHAR(255), name VARCHAR(256) NOT NULL, TCDRIVER_ID BIGINT, PRIMARY KEY NONCLUSTERED (JAVA_PLUGIN_ID));
CREATE TABLE WKF_JAVA_PLUGIN_PARAMETER (JAVA_PLUGIN_PARAMETER_ID BIGINT NOT NULL, array BIT, defaultValue VARCHAR(255), IS_ENCRYPTED VARCHAR(1) NOT NULL, IS_INPUT VARCHAR(1) NOT NULL, IS_OUTPUT VARCHAR(1) NOT NULL, PARAMETER_NAME VARCHAR(256) NOT NULL, JAVA_PLUGIN_ID BIGINT NOT NULL, PRIMARY KEY NONCLUSTERED (JAVA_PLUGIN_PARAMETER_ID));
CREATE TABLE WKF_REQUEST_CONTEXT_VARIABLE (REQUEST_CONTEXT_VARIABLE_ID BIGINT NOT NULL, ARRAY_INDEX INT, description VARCHAR(2000), ENCRYPTED_B VARCHAR(1) NOT NULL, guid VARCHAR(128), INPUT_B VARCHAR(1) NOT NULL, name VARCHAR(256) NOT NULL, OUTPUT_B VARCHAR(1) NOT NULL, OUTPUT_VALUE VARCHAR(4000), value VARCHAR(4000), DEPLOYMENT_REQUEST_ID BIGINT NOT NULL, PRIMARY KEY NONCLUSTERED (REQUEST_CONTEXT_VARIABLE_ID));
CREATE TABLE WKF_REQUEST_PARAM (REQUEST_CONTEXT_VARIABLE_ID BIGINT NOT NULL, array BIT, description VARCHAR(2000), ENCRYPTED_B VARCHAR(1) NOT NULL, guid VARCHAR(128), ARRAY_INDEX INT NOT NULL, INPUT_B VARCHAR(1) NOT NULL, inputValue VARCHAR(4000), name VARCHAR(256) NOT NULL, OUTPUT_B VARCHAR(1) NOT NULL, OUTPUT_VALUE VARCHAR(4000), DEPLOYMENT_REQUEST_ID BIGINT NOT NULL, PRIMARY KEY NONCLUSTERED (REQUEST_CONTEXT_VARIABLE_ID));
CREATE TABLE WKF_RESOURCE_REQUEST_LOCK (RESOURCE_REQUEST_LOCK_KEY_ID BIGINT NOT NULL, ACQUIRE_DATETIME DATETIME, DCM_OBJECT_ID BIGINT NOT NULL, LOCK_KEY BIGINT, DEPLOYMENT_REQUEST_ID BIGINT NOT NULL, PRIMARY KEY NONCLUSTERED (RESOURCE_REQUEST_LOCK_KEY_ID));
CREATE TABLE WKF_TCDRIVER (TCDRIVER_ID BIGINT NOT NULL, descriptor TEXT, name VARCHAR(255), version VARCHAR(256) NOT NULL, PRIMARY KEY NONCLUSTERED (TCDRIVER_ID));
CREATE TABLE WKF_TCDRIVER_FILE (TCDRIVER_FILE_ID BIGINT NOT NULL, destination VARCHAR(2000) NOT NULL, source VARCHAR(2000) NOT NULL, type VARCHAR(256), TCDRIVER_ID BIGINT NOT NULL, PRIMARY KEY NONCLUSTERED (TCDRIVER_FILE_ID));
CREATE TABLE WKF_WORKFLOW (WORKFLOW_ID BIGINT NOT NULL, deprecated VARCHAR(2000), DEVICE_MODEL VARCHAR(255), IMPLEMENTS_LDO VARCHAR(255), IS_EDITABLE VARCHAR(1) NOT NULL, IS_LOGICAL_OPERATION VARCHAR(1) NOT NULL, LEGACY_WORKFLOW_ID VARCHAR(36), LOCALE_SENSITIVE VARCHAR(1) NOT NULL, WORKFLOW_NAME VARCHAR(255) NOT NULL, DTYPE VARCHAR(255), TCDRIVER_ID BIGINT, SOURCE_CODE TEXT, PRIMARY KEY NONCLUSTERED (WORKFLOW_ID));
CREATE INDEX I_WKF_JCT_DCMOBJECT ON WKF_DCM_OBJECT (PHYSICAL_CONTAINER_ID);
CREATE INDEX I_WKF_JCT_DCMOBJECTTYPE ON WKF_DCM_OBJECT (TYPE_ID);
CREATE INDEX I_WKF_JCT_DEVICEMODEL2 ON WKF_DCM_OBJECT (DEVICE_MODEL_ID);
CREATE INDEX I_WKF_FLW_DCMOBJECT ON WKF_DCM_OBJECT_WORKFLOW (DCM_OBJECT_ID);
CREATE INDEX I_WKF_MDL_DCMOBJECT ON WKF_DEVICE_MODEL (DCM_OBJECT_ID);
CREATE INDEX I_WKF_MDL_TCDRIVER ON WKF_DEVICE_MODEL (TCDRIVER_ID);
CREATE INDEX I_WKF_DLR_INSTRUCTION ON WKF_EXCEPTION_HANDLER (INSTRUCTION_ID);
CREATE INDEX I_WKF__LG_DEPLOYMENTREQUEST ON WKF_EXECUTION_LOG (DEPLOYMENT_REQUEST_ID);
CREATE INDEX I_WKF_DTL_WORKFLOWEXECUTIONLOG ON WKF_EXECUTION_LOG_DETAIL (LOG_ID);
CREATE INDEX I_WKF_MTR_WORKFLOW ON WKF_FORMAL_PARAMETER (WORKFLOW_ID);
CREATE INDEX I_WKF_PRM_FORMALPARAMETER ON WKF_FORMAL_PARM_PERM (FORMAL_PARAMETER_ID);
CREATE INDEX I_WKF_CTN_WORKFLOW ON WKF_INSTRUCTION (WORKFLOW_ID);
CREATE INDEX I_WKF_RND_DTYPE ON WKF_INSTRUCTION_OPERAND (OPERAND_TYPE);
CREATE INDEX I_WKF_RND_INSTRUCTION ON WKF_INSTRUCTION_OPERAND (INSTRUCTION_ID);
CREATE INDEX I_WKF_RND_WORKFLOW ON WKF_INSTRUCTION_OPERAND (WORKFLOW_ID);
CREATE INDEX I_WKF_LGN_TCDRIVER ON WKF_JAVA_PLUGIN (TCDRIVER_ID);
CREATE INDEX I_WKF_MTR_JAVAPLUGININFO ON WKF_JAVA_PLUGIN_PARAMETER (JAVA_PLUGIN_ID);
CREATE INDEX I_WKF_RBL_DEPLOYMENTREQUEST ON WKF_REQUEST_CONTEXT_VARIABLE (DEPLOYMENT_REQUEST_ID);
CREATE INDEX I_WKF_PRM_DEPLOYMENTREQUEST ON WKF_REQUEST_PARAM (DEPLOYMENT_REQUEST_ID);
CREATE INDEX I_WKF_LCK_DEPLOYMENTREQUEST ON WKF_RESOURCE_REQUEST_LOCK (DEPLOYMENT_REQUEST_ID);
CREATE INDEX I_WKF__FL_TCDRIVER ON WKF_TCDRIVER_FILE (TCDRIVER_ID);
CREATE INDEX I_WKF_FLW_DTYPE ON WKF_WORKFLOW (DTYPE);
CREATE INDEX I_WKF_FLW_TCDRIVER ON WKF_WORKFLOW (TCDRIVER_ID);
