#!/bin/sh
# Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2010, 2011 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
# IBM_COPYRIGHT_END

#  
# ======================================================================= 


# Check arguments
if [ $# -ne 6 ]; then
  echo "usage $0 
	-p scanPath -o outputFile (MUST be absolute path) -r recursive [true|false]" 1>&2
  exit 1
fi

for I in $*
do
  case $I in 
  	-p)
        scanRootPath=$2; shift 2;;
    -o)
        outputFile=$2; shift 2;;
    -r)
        recursive=$2; shift 2;;
  esac	
done

function list_dir {  
  # Check if the dir exists		  
  if [ ! -d $1 ]; then
  echo "$1 No such file or directory" 1>&2
	exit 1
  fi
  recursionFlag=""   
  if [ "$recursive" == true ]; then
	recursionFlag="R"
  fi  
  cd $1 

  lines=`ls -1A$recursionFlag` 
  for line in $lines
  do
	# When using -1 flag some lines contain dir names starting with "./" and ending with ":"
	echo $line | grep "\./.*:"
	if [ $? = 0 ]; then
		relPath=`echo $line | sed -e 's@:$@/@'`
		continue
    # Note that the belov does NOT support symlinks  
	elif [ -f $relPath$line ]; then	
		fullPath=$relPath$line
		leadingChars=`echo $fullPath | cut -b 1-2`
		if [ $leadingChars == "./" ]; then
			fullPath=`echo $fullPath | cut -b 3-`
		fi
		echo $fullPath >> $outputFile	
	fi
  done
}

list_dir $scanRootPath
