' Licensed Materials - Property of IBM
'
' (C) Copyright IBM Corp. 2010, 2011 All Rights Reserved
'
' US Government Users Restricted Rights - Use, duplicate or
' disclosure restricted by GSA ADP Schedule Contract with
' IBM Corp.
' IBM_COPYRIGHT_END

'  
' ============================================================================ 

Function ReplaceChars(RESULT)
     Dim lookFor(6), repLace(6)
     lookFor(0) = "&"
     lookFor(1) = "%"
     lookFor(2) = """"
     lookFor(3) = "<"
     lookFor(4) = ">"
     lookFor(5) = "\\"
     repLace(0) = "&amp;"
     repLace(1) = "&#37;"
     repLace(2) = "&quot;"
     repLace(3) = "&lt;"
     repLace(4) = "&gt;"
     repLace(5) = "\\\\\\"

     set objRE = new RegExp
     objRE.Global = True
     objRE.IgnoreCase = True
     objRE.MultiLine = True

     For i = 0 To Ubound(lookFor)-1 Step 1
          objRE.pattern = lookFor(i)
          replaceString = repLace(i)
          RESULT = objRE.Replace(RESULT, replaceString)
     Next
     ReplaceChars = RESULT
End Function


Function TIOthrow (EXCEPTION, MESSAGE)
  MESSAGE = ReplaceChars(MESSAGE)
  WScript.Echo "<tio><throw exception=""" & EXCEPTION & """>" & MESSAGE & "</throw></tio>"
End Function


Function TIOlog (LEVEL, MESSAGE)
  MESSAGE = ReplaceChars(MESSAGE)
  WScript.Echo "<tio><log level=""" & LEVEL & """>" & MESSAGE & "</log></tio>"
End Function

'There are 5 mandatory parameters (section is optional)
Set objArguments = WScript.Arguments
If (objArguments.Count <> 5) Then
	WScript.Echo "Error in ./update_config_variable.vbs - Invalid Argument Count"
	WScript.Echo "Syntax: ./update_config_variable.vbs fileName filePath section(optional) varName newValue delimiter"
	WScript.Quit 1
End If

Set args = WScript.Arguments
fileName = args(0)
filePath = args(1)
section = args(2)
varName = args(3)
newValue = args(4)
configDelim = args(5)

Dim location
If (StrComp(Right(filePath, 1), "\") = 0) Then
  location = filePath & fileName
Else
  location = filePath & "\" & fileName
End If

Dim oFSO : Set oFSO = CreateObject("Scripting.FileSystemObject")

If (not oFSO.FileExists(location)) Then
  TIOThrow "FileDoesNotExist", "The file does not exist at the following path:  " & location
  WScript.Quit 1
End If

Dim backupLocation
backupLocation = location & ".backup"

If (oFSO.FileExists(backupLocation)) Then
  oFSO.DeleteFile backupLocation, True
End If

oFSO.MoveFile location, backupLocation

Dim orig
Set orig = oFSO.OpenTextFile(backupLocation, 1, False)
Dim originalContent

Dim dest
Set dest = oFSO.CreateTextFile(location, True)

Dim line
Dim lineLength
Dim inSection : inSection = False
Dim sectionLength : sectionLength = Len(section)
Dim varLength : varLength = Len(varName)
Dim posSpace

Dim posVar
Dim varFound
Dim isVar
Dim isSpace
Dim isConfigDelim
Dim isTab

Dim posDelim
Dim cutToDelim
Dim isSpaceBefore

Dim char
Dim isSpaceChar
Dim isTabChar
Dim counter
Dim determ : determ = False
Dim cutAfterDelim

fileName = Trim(fileName)
filePath = Trim(filePath)
varName = Trim(varName)
newValue = Trim(newValue)
section = Trim(section)
configDelim = Trim(configDelim)

Do Until orig.AtEndOfStream
	line = orig.ReadLine()
	lineLength = Len(line)
	trimmed = Trim(line)
 	
	counter = 1
	
	If ((StrComp(section, "") = 0)) Then 
		'---No section parameter was supplied so remediate all instances of the variable
		WScript.Echo "section parameter is empty so remediating all instances of the variable"
		inSection = True
	Else
		'---A section parameter was supplied so determine if we are in the correct section  	
  		If (StrComp(Left(trimmed, lineLength), section ) = 0) Then
    		inSection = True   
    	End If
  	End If
  		
	'---Find the position of the variable name if it exists in the current line
	posVar = InStr(line, varName)
	
	'---If the return value fron InStr is not null and non-zero then the variable name has been found	
	If ((not isNull(posVar)) And (posVar <> 0)) Then	

		'---Check to see that the actual variable name has been found (ie: it must be preceeded by the start of the line or any number of spaces or tabs, 
		'---and it must be followed by any number of spaces or tabs or the delimiter)		
		If(posVar <> 1) Then
	
			'--check to make sure that only spaces or tabs preceed the variable name
			isSpaceBefore = Left(line, (posVar - 1))
			isSpaceBefore = Right(isSpaceBefore, 1)			
			
			If ((StrComp(isSpaceBefore, " ") = 0) Or (StrComp(isSpaceBefore, vbTab) = 0)) Then
				'--If only spaces or tabs preceed the variable name, then check the characters following the variable name
				varFound = Mid(line, posVar, (varLength + 1))
				isVar = Right(varFound, 1)
				isSpace = StrComp(isVar, " ")
				isConfigDelim = StrComp(isVar, configDelim)
				isTab = StrComp(isVar, vbTab)
						
				If (((isSpace = 0) Or (isConfigDelim = 0) Or (isTab = 0)) And inSection) Then
				
					'We have to get the "cutToDelim" and "cutAfterDelim" only after we find an exact match for the variable
					'because if a loose match for the variable is not using the supplied delimiter, the script will fail
				
					'---Get the portion of the line before the delimiter		
					posDelim = InStr(line, configDelim)
					cutToDelim = Left(line, (posDelim - 1))
				
					'---Get the portion of the line after the delimiter and before the value
					Do Until determ	
						char = Left(line, (posDelim + counter))
						char = Right(char, 1)
						isSpaceChar = StrComp(char, " ")
						isTabChar = StrComp(char, vbTab)
						If ((isSpaceChar = 0) Or (isTabChar = 0)) Then
							'---We have not yet found the variable value
							determ = False
							counter = counter + 1
						Else
							'--We have reached the variable value
							determ = True
							cutAfterDelim = Left(line, (posDelim + counter - 1))
							cutAfterDelim = Right(cutAfterDelim, ((posDelim + counter - 1) - posDelim))
						End If		
					Loop			
			
					determ = False
				
					'---Print the line with the new value			
					dest.WriteLine cutToDelim & configDelim & cutAfterDelim & newValue					
					inSection = False
				Else
					dest.WriteLine line
				End If
			End If
		Else
			'---There are no spaces or tabs before the variable name so check the characters following the variable name			
			varFound = Mid(line, posVar, (varLength + 1))
			isVar = Right(varFound, 1)
			isSpace = StrComp(isVar, " ")
			isConfigDelim = StrComp(isVar, configDelim)
			isTab = StrComp(isVar, vbTab)
			If (((isSpace = 0) Or (isConfigDelim = 0) Or (isTab = 0)) And inSection) Then	
			
				'We have to get the "cutToDelim" and "cutAfterDelim" only after we find an exact match for the variable
				'because if a loose match for the variable is not using the supplied delimiter, the script will fail
				
				'---Get the portion of the line before the delimiter		
				posDelim = InStr(line, configDelim)
				cutToDelim = Left(line, (posDelim - 1))
				
				'---Get the portion of the line after the delimiter and before the value
				Do Until determ	
					char = Left(line, (posDelim + counter))
					char = Right(char, 1)
					isSpaceChar = StrComp(char, " ")
					isTabChar = StrComp(char, vbTab)
					If ((isSpaceChar = 0) Or (isTabChar = 0)) Then
						'---We have not yet found the variable value
						determ = False
						counter = counter + 1
					Else
						'--We have reached the variable value
						determ = True
						cutAfterDelim = Left(line, (posDelim + counter - 1))
						cutAfterDelim = Right(cutAfterDelim, ((posDelim + counter - 1) - posDelim))
					End If		
				Loop			
			
				determ = False
			
				'---Print the line with the new value			
				dest.WriteLine cutToDelim & configDelim & cutAfterDelim & newValue	
				inSection = False
			Else
				dest.WriteLine line
			End If
		End If
	Else
		dest.WriteLine line
	End If
Loop

orig.Close
dest.Close