
# Licensed Materials - Property of IBM
# OCO Source Materials
# 09N6996
# (C) Copyright IBM Corp. 2007-2010 All Rights Reserved
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office. 
# ======================================================================= 

#
# Execute ksh script
#
proc TIOthrow {exception message} {

   regsub -all {&} $message "\\&amp;" message
   regsub -all {\%} $message "\\&#37;" message
   regsub -all {\"} $message "\\&quot;" message
   regsub -all {<} $message "\\&lt;" message
   regsub -all {>} $message "\\&gt;" message

   puts "<tio><throw exception=\"$exception\">$message</throw></tio>"
}

expect {
  -re "$PROMPT$" {send "cd $SCRIPT_DIR\r"}
}

# set workflow variables
# @TODO escape variable values!
foreach {var val} [array get wfvars] {
  expect {
    -re "$PROMPT$" {send "$var=\'$val\'\r"}
  }
}

expect {
  -re "$PROMPT$" {send ". ./$SCRIPT_NAME\r"}
}

expect -exact "$SCRIPT_NAME"
send  "\r"

# @TODO -ex "</tio>" does not seem to work, if output bigger than couple
# of kilobytes it gets truncated
#
# @TODO "rm -f ./$SCRIPT_NAME" does not work
expect {

  -ex "</tio>" {
     puts "$expect_out(buffer)"
     exp_continue
  }

  -re "$PROMPT$" {
     puts "$expect_out(buffer)"
     set error_message "$expect_out(buffer)"
     send "if \[ $? = 0 \]; then  echo '\\nokokok\\c\'; else  echo '\\nfailfailfail\\c'; fi ; echo 'end' \r"
     expect {

        -re "okokokend.*" {
     		send "rm -f ./$SCRIPT_NAME\r"
        	expect {
               		 -re "$PROMPT$" { send "exit\r" }
        	}
        	if [info exists prompt] { 
            expect {
					-re "$prompt" { send "exit\r" }
			   	   }
            }
        	
	}

	-re "failfailfailend.*" {
		TIOthrow scriptletFailed "The scriptlet exited with a non-zero return. $error_message"
     		send "rm -f ./$SCRIPT_NAME\r"
        	expect {
               		 -re "$PROMPT$" { send "exit\r" }
        	}
        	if [info exists prompt] { 
            expect {
					-re "$prompt" { send "exit\r" }
			   	   }
            }
        }
     }
  }
}
